#include <stdio.h>
//#define XMC_DISABLE_SUPERBLOCKS
#include "Xmalloc.cu"
typedef struct                      /* Polygon set structure             */
{
  int                 num_contours;
  int                *hole;         /* Hole / external contour flags     */
} gpc_polygon;

//start measuring time
void startMeasureTime(cudaEvent_t start, cudaEvent_t stop){
	cudaEventRecord(start, 0);
}

//finishing measuring time
void endMeasureTime(cudaEvent_t start, cudaEvent_t stop, char * comment){
	float time_kernel; 
	cudaEventRecord(stop, 0);
	cudaEventSynchronize(stop);
	cudaEventElapsedTime(&time_kernel, start, stop);
	printf("%s takes %f ms\n", comment,time_kernel);
}


__global__ void Test(int *sample,int num,gpc_polygon* output){
	int tx=threadIdx.x;
	int bx=blockIdx.x;
	gpc_polygon* pointer=(gpc_polygon*)xmcMalloc(sizeof(gpc_polygon));
	//gpc_polygon* pointer=(gpc_polygon*)malloc(sizeof(gpc_polygon));
	pointer->num_contours=sample[tx+bx*512];
	output[tx+bx*512]=*pointer;
}
int main(int argc , char **argv){
	int num=512*250;
	int *sample;
	int *data;
	int i,j;
	cudaEvent_t start_event, stop_event;
	cudaEventCreate(&start_event) ;
	cudaEventCreate(&stop_event) ;
	//xmcInit();
	cudaMalloc((int**)&sample,num*sizeof(int));
	data=(int*)malloc(sizeof(int)*num);
	gpc_polygon* output;
	cudaMalloc((gpc_polygon**)&output,num*sizeof(gpc_polygon));
	gpc_polygon* output_cpu;
	output_cpu=(gpc_polygon*)malloc(sizeof(gpc_polygon)*num);

	for(i=0;i<num;i++){
		data[i]=i;
	}
	(cudaMemcpy( sample, data, num*sizeof( int), cudaMemcpyHostToDevice) );
	dim3 dimGrid(250,1);
	dim3 dimBlock(512,1);
	startMeasureTime(start_event,stop_event);
	//checkErrors("Result copying \n");
	endMeasureTime(start_event,stop_event,"Time for allocating global memory");
	Test<<<dimGrid,dimBlock>>>(sample,num,output);
    cudaThreadSynchronize(); 
    //make the CPU wait till all previously launched kernels terminate
    (cudaMemcpy( output_cpu,output, sizeof(gpc_polygon) * num, cudaMemcpyDeviceToHost));
    for(i=num-2;i<num;i++){
    	printf("%d=%d\n",i,output_cpu[i].num_contours);
    }
    free(data);
    cudaFree( sample);
    free(output_cpu);
    cudaFree( output);
    return 0;
}
