//work efficient algorithm without optimization
// when working with float data, output are not correct. 
#include <stdio.h>
#define datatype int
#include "util.h"

__global__ void scan1(datatype *g_data, datatype *output,int size,int flag) {
	extern __shared__ datatype temp[];// allocated on invocation 
	//int thid = threadIdx.x;
	int offset = 1;
	int tx=threadIdx.x;
	int bx=blockIdx.x;
	int base=bx*size/2;
	int thid = tx+base;
	
	temp[2*tx] = g_data[2*thid]; 
	temp[2*tx+1] = g_data[2*thid+1];	
	temp[2*tx+size]=temp[2*tx]; 
	temp[2*tx+size+1]=temp[2*tx+1]; 
	for (int d = size>>1; d > 0; d >>= 1){ // build sum in place up the tree {
		__syncthreads();
		if (tx < d) {
			int ai =offset*(2*tx+1)-1;
			int bi =offset*(2*tx+2)-1;
			temp[bi]+=temp[ai];
		}
		offset*=2;
	}
	if(tx==0){
		temp[size-1]=0;
	}
	for(int d=1;d<size;d*=2){
		offset>>=1;
		__syncthreads();
		if(tx<d){ 
			int ai =offset*(2*tx+1)-1;
			int bi =offset*(2*tx+2)-1;
			datatype t=temp[ai];
			temp[ai]=temp[bi];
			temp[bi]+=t;
		}
	}	
	__syncthreads();
	temp[2*tx]=temp[2*tx]+temp[2*tx+size]; 
	temp[2*tx+1]=temp[2*tx+1]+temp[2*tx+size+1]; 
	g_data[2*thid]=temp[2*tx];
	g_data[2*thid+1]=temp[2*tx+1];
	if((tx==size/2-1) && flag) {
		output[bx]=temp[2*tx+1];
	}	
}

__global__ void scan2(datatype *g_data, datatype *output,int size) {
	int tx=threadIdx.x;
	int bx=blockIdx.x;
	int base=bx*size/2;
	int thid = tx+base;
	if(bx!=0){ 
		g_data[thid*2]=g_data[thid*2]+output[bx-1];	
		g_data[thid*2+1]=g_data[thid*2+1]+output[bx-1];	
	}
}

void scan(int *g_data,int length,int size){
    int i; 
    int diff;
    int firstBlocks=(length-1)/size+1;
	int len1=firstBlocks*size;
    int secondBlocks=(firstBlocks-1)/size+1;
    int len2=secondBlocks*size;
    cudaError_t err;

		
    datatype* firstOutput=0;
    datatype* secondOutput=0;
    datatype* data = (datatype*) malloc((len1-length)*sizeof(datatype));
    err=  (cudaMalloc( (void**) &firstOutput, len2*sizeof(datatype)));
    if( err != cudaSuccess)
	{
    	printf("CUDA error s1: %s\n", cudaGetErrorString(err));
     	exit(-1);
	}

    
    for(i = length; i < len1; i++) 
    {
        data[i-length] = 0;//(int)(10 * rand()/32768.f);
    }
    err=   (cudaMemcpy( g_data+length, data, sizeof(datatype)*(len1-length), cudaMemcpyHostToDevice) );
    if( err != cudaSuccess)
	{
    	printf("CUDA error s2: %s\n", cudaGetErrorString(err));
     	exit(-1);
	}
    
    dim3 dimBlock(size/2,1,1);
    dim3 dimGrid(firstBlocks,1);
    dim3 dimGrid2(secondBlocks,1);
    dim3 singleGrid(1,1);

	scan1<<<dimGrid, dimBlock,2*size*sizeof(datatype)>>>(g_data,firstOutput,size,1);
	if(firstBlocks!=len2){
		diff=len2-firstBlocks;
		datatype* padding = (datatype*) malloc((diff)*sizeof(datatype));
		for(i=0;i<diff;i++){
			padding[i]=0;
		}
		err= (cudaMemcpy((firstOutput+firstBlocks), padding, sizeof(datatype)*diff, cudaMemcpyHostToDevice) );
    	if( err != cudaSuccess)
		{
    		printf("CUDA error s3: %s\n", cudaGetErrorString(err));
     		exit(-1);
		}
	}
	if(firstBlocks>size){ 
    	err= (cudaMalloc( (void**) &secondOutput, size*sizeof(datatype)));
    	if( err != cudaSuccess)
		{
    		printf("CUDA error s4: %s\n", cudaGetErrorString(err));
     		exit(-1);
		}
    	if(secondBlocks<size){
    		diff=size-secondBlocks;
    		datatype* padding1 = (datatype*) malloc(diff*sizeof(datatype));
    		for(i=0;i<diff;i++){
				padding1[i]=0;
			}
    		err= (cudaMemcpy((secondOutput+secondBlocks), padding1, sizeof(datatype)*diff, cudaMemcpyHostToDevice) );
    		if( err != cudaSuccess)
			{
    			printf("CUDA error s5: %s\n", cudaGetErrorString(err));
     			exit(-1);
			}
    	}
    	scan1<<<dimGrid2, dimBlock,2*size*sizeof(datatype)>>>(firstOutput,secondOutput,size,1);
 	   	scan1<<<singleGrid, dimBlock,2*size*sizeof(datatype)>>>(secondOutput,secondOutput,size,0);
    	scan2<<<dimGrid2, dimBlock>>>(firstOutput,secondOutput,size);
    	scan2<<<dimGrid, dimBlock>>>(g_data,firstOutput,size);
    }
    else{
    	scan1<<<singleGrid, dimBlock,2*size*sizeof(datatype)>>>(firstOutput,firstOutput,size,0);
    	scan2<<<dimGrid, dimBlock>>>(g_data,firstOutput,size);
    }
	free(data);     
    err= cudaFree(firstOutput);
    if( err != cudaSuccess)
	{
    	printf("CUDA error s6: %s\n", cudaGetErrorString(err));
     	exit(-1);
	}
}
