#include "spaceFillingCurve.h"

__global__ void CalcuateZOrderValue(int *rect1_gpu,int *rect2_gpu,int *rect3_gpu,int *rect4_gpu,long long int *x1,long long int *x2,long long int *x3,long long int *x4,long long int *y1,long long int *y2,long long int *y3,long long int *y4,bounding_box *zOrder,int num,int minX,int minY){
	int tx=threadIdx.x;
	int bx=blockIdx.x;
	int thid = tx+bx*blockDim.x;
	int multiplier=1;
  	if(thid<num)
  	{ 
    	x1[thid]=(long long int )(rect1_gpu[thid]*multiplier);
    	x2[thid]=(long long int )(rect2_gpu[thid]*multiplier);
    	x3[thid]=(long long int )(rect3_gpu[thid]*multiplier);
    	x4[thid]=(long long int )(rect4_gpu[thid]*multiplier);
    	y1[thid]=(long long int )(x1[thid]-(long long int )(minX*multiplier));
    	y2[thid]=(long long int )(x2[thid]-(long long int )(minY*multiplier));
    	y3[thid]=(long long int )(x3[thid]-(long long int )(minX*multiplier));
    	y4[thid]=(long long int )(x4[thid]-(long long int )(minY*multiplier));
    	zOrder[thid].zOrderValue=Interleave(y1[thid],y2[thid],y3[thid],y4[thid]);
    	zOrder[thid].index=thid;
  	}
}

/* Calculate the z-order value for each bounding box using its four coordiantes*/
/* the algorithm is described at http://www-graphics.stanford.edu/~seander/bithacks.html#InterleaveBMN */
__device__ unsigned long long int Interleave(unsigned long long int a1,unsigned long long int a2,unsigned long long int a3,unsigned long long int a4){
	
	unsigned long long int B[] = {0x0303030303030303, 0x000F000F000F000F, 0x000000FF000000FF};	
	unsigned int S[] = {6,12,24};
	unsigned long long int value;
               
	a1 = (a1 | (a1 << S[2])) & B[2];
	a1 = (a1 | (a1 << S[1])) & B[1];
	a1 = (a1 | (a1 << S[0])) & B[0];
	
	a2 = (a2 | (a2 << S[2])) & B[2];
	a2 = (a2 | (a2 << S[1])) & B[1];
	a2 = (a2 | (a2 << S[0])) & B[0];
	
	a3 = (a3 | (a3 << S[2])) & B[2];
	a3 = (a3 | (a3 << S[1])) & B[1];
	a3 = (a3 | (a3 << S[0])) & B[0];
	
	a4 = (a4 | (a4 << S[2])) & B[2];
	a4 = (a4 | (a4 << S[1])) & B[1];
	a4 = (a4 | (a4 << S[0])) & B[0];
	
	value= (a1<<6) | (a2 << 4)|(a3<<2)|a4;
	//printf("%llx\n",value);
	return value;
}
