#include <stdio.h>
typedef struct                      
{
  int             * p;            
  int              num;            
} Structure_A;

__global__ void Execute(Structure_A *output);

int main(){
   
    Structure_A *output;
    cudaMalloc((void***)&output,sizeof(Structure_A)*1);
	dim3 dimBlockExecute(1,1);
	dim3 dimGridExecute(1,1);
    Execute<<<dimGridExecute,dimBlockExecute>>>(output);
    Structure_A * output_cpu;
    int * p_cpu;
	cudaError_t err;

    output_cpu= (Structure_A*)malloc(1);
   	err=cudaMemcpy(output_cpu,output,sizeof(Structure_A),cudaMemcpyDeviceToHost);	 
   	if( err != cudaSuccess)
	{
		printf("CUDA error a: %s\n", cudaGetErrorString(err));
		exit(-1);
	}
	p_cpu=(int *)malloc(1);
   	err=cudaMemcpy(p_cpu,output_cpu[0].p,sizeof(int),cudaMemcpyDeviceToHost);	 
   	if( err != cudaSuccess)
	{
		printf("CUDA error b: %s\n", cudaGetErrorString(err));
		exit(-1);
	}	
	printf("output=(%d,%d)\n",output_cpu[0].num,p_cpu[0]);
	return 0;
}

__global__ void Execute(Structure_A *output){
    int thid=threadIdx.x;
    output[thid].p= (int*)malloc(thid+1);
    output[thid].num=(thid+1);
    output[thid].p[0]=5;
}